//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%382C7C8B7768.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%382C7C8B7768.cm

//## begin module%382C7C8B7768.cp preserve=no
//## end module%382C7C8B7768.cp

//## Module: ParamData%382C7C8B7768; Package specification
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Parameter/ParamData.h

#ifndef PARAMDATA_H
#define PARAMDATA_H 1

//## begin module%382C7C8B7768.additionalIncludes preserve=no
//## end module%382C7C8B7768.additionalIncludes

//## begin module%382C7C8B7768.includes preserve=yes
//## end module%382C7C8B7768.includes

// xsTypes
#include "xsTypes.h"
//## begin module%382C7C8B7768.declarations preserve=no
//## end module%382C7C8B7768.declarations

//## begin module%382C7C8B7768.additionalDeclarations preserve=yes
//## end module%382C7C8B7768.additionalDeclarations


//## begin ParamData%3628CFD700D2.preface preserve=yes
//## end ParamData%3628CFD700D2.preface

//## Class: ParamData%3628CFD700D2; Abstract
//	The  class Param encapulates the common data elements
//	of model and fit parameters. They have functions that
//	get, set and print them, and 6 data members, which are
//	read into
//	the program from the model.dat file by ModParam objects.
//	//	value - the parameter value
//	value - the parameter value
//	max - the specified upper limit of the parameter > top
//	min - the specified lower limit of the parameter < bot
//	top - the top of the parameter pegged range
//	bot - the bottom of the parameter pegged range
//	delta - the fitting routine default stepsize
//## Category: XSModel::Parameter%36349D8902D7
//## Subsystem: XSModel::Parameter%367691A8CEA0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class ParamData 
{
  //## begin ParamData%3628CFD700D2.initialDeclarations preserve=yes
  //## end ParamData%3628CFD700D2.initialDeclarations

  public:
    //## Constructors (generated)
      ParamData(const ParamData &right);

    //## Constructors (specified)
      //## Operation: ParamData%382C86431718
      ParamData (Real value = 0., Real delta = 0., Real max = 0., Real min = 0., Real top = 0., Real bot = 0.);

    //## Destructor (generated)
      ~ParamData();

    //## Assignment Operation (generated)
      ParamData & operator=(const ParamData &right);

    //## Equality Operations (generated)
      int operator==(const ParamData &right) const;

      int operator!=(const ParamData &right) const;


    //## Other Operations (specified)
      //## Operation: init%38E3C7659AC8
      void init (Real values, Real delta, Real max, Real min, Real top, Real bottom);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: value%373B0D30FFE3
      const Real value () const;
      void value (Real value);

      //## Attribute: delta%373B0D30FFE4
      //	The size of the parameter step taken by the fitting
      //	routine
      const Real delta () const;
      void delta (Real value);

      //## Attribute: max%373B0D30FFE1
      const Real max () const;
      void max (Real value);

      //## Attribute: min%373B0D30FFE2
      const Real min () const;
      void min (Real value);

      //## Attribute: top%373B0D30FFE5
      const Real top () const;
      void top (Real value);

      //## Attribute: bot%373B0D30FFE6
      const Real bot () const;
      void bot (Real value);

    // Additional Public Declarations
      //## begin ParamData%3628CFD700D2.public preserve=yes
      //## end ParamData%3628CFD700D2.public

  protected:
    // Additional Protected Declarations
      //## begin ParamData%3628CFD700D2.protected preserve=yes
      //## end ParamData%3628CFD700D2.protected

  private:
    // Additional Private Declarations
      //## begin ParamData%3628CFD700D2.private preserve=yes
      //## end ParamData%3628CFD700D2.private

  private: //## implementation

    //## Other Operations (specified)
      //## Operation: compare%382C90AB55D0
      bool compare (const ParamData& right) const;

      //## Operation: swap%3A8D68D80112
      //## Exceptions: ()
      void swap (ParamData& right) throw ();

    // Data Members for Class Attributes

      //## begin ParamData::value%373B0D30FFE3.attr preserve=no  public: Real {U} 0.
      Real m_value;
      //## end ParamData::value%373B0D30FFE3.attr

      //## begin ParamData::delta%373B0D30FFE4.attr preserve=no  public: Real {U} 0.
      Real m_delta;
      //## end ParamData::delta%373B0D30FFE4.attr

      //## begin ParamData::max%373B0D30FFE1.attr preserve=no  public: Real {U} 0.
      Real m_max;
      //## end ParamData::max%373B0D30FFE1.attr

      //## begin ParamData::min%373B0D30FFE2.attr preserve=no  public: Real {U} 0.
      Real m_min;
      //## end ParamData::min%373B0D30FFE2.attr

      //## begin ParamData::top%373B0D30FFE5.attr preserve=no  public: Real {U} 0.
      Real m_top;
      //## end ParamData::top%373B0D30FFE5.attr

      //## begin ParamData::bot%373B0D30FFE6.attr preserve=no  public: Real {U} 0.
      Real m_bot;
      //## end ParamData::bot%373B0D30FFE6.attr

    // Additional Implementation Declarations
      //## begin ParamData%3628CFD700D2.implementation preserve=yes
      //## end ParamData%3628CFD700D2.implementation

};

//## begin ParamData%3628CFD700D2.postscript preserve=yes
//## end ParamData%3628CFD700D2.postscript

// Class ParamData 

inline int ParamData::operator==(const ParamData &right) const
{
  //## begin ParamData::operator==%3628CFD700D2_eq.body preserve=yes
  return compare(right);
  //## end ParamData::operator==%3628CFD700D2_eq.body
}

inline int ParamData::operator!=(const ParamData &right) const
{
  //## begin ParamData::operator!=%3628CFD700D2_neq.body preserve=yes
  return !compare(right);
  //## end ParamData::operator!=%3628CFD700D2_neq.body
}



//## Other Operations (inline)
inline bool ParamData::compare (const ParamData& right) const
{
  //## begin ParamData::compare%382C90AB55D0.body preserve=yes
        if (m_value != right.m_value) return false;
        if (m_delta != right.m_delta) return false;
        if (m_top != right.m_top) return false;
        if (m_bot != right.m_bot) return false;
        if (m_max != right.m_max) return false;
        if (m_min != right.m_min) return false;
        return true;
  //## end ParamData::compare%382C90AB55D0.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const Real ParamData::value () const
{
  //## begin ParamData::value%373B0D30FFE3.get preserve=no
  return m_value;
  //## end ParamData::value%373B0D30FFE3.get
}

inline void ParamData::value (Real value)
{
  //## begin ParamData::value%373B0D30FFE3.set preserve=no
  m_value = value;
  //## end ParamData::value%373B0D30FFE3.set
}

inline const Real ParamData::delta () const
{
  //## begin ParamData::delta%373B0D30FFE4.get preserve=no
  return m_delta;
  //## end ParamData::delta%373B0D30FFE4.get
}

inline void ParamData::delta (Real value)
{
  //## begin ParamData::delta%373B0D30FFE4.set preserve=no
  m_delta = value;
  //## end ParamData::delta%373B0D30FFE4.set
}

inline const Real ParamData::max () const
{
  //## begin ParamData::max%373B0D30FFE1.get preserve=no
  return m_max;
  //## end ParamData::max%373B0D30FFE1.get
}

inline void ParamData::max (Real value)
{
  //## begin ParamData::max%373B0D30FFE1.set preserve=no
  m_max = value;
  //## end ParamData::max%373B0D30FFE1.set
}

inline const Real ParamData::min () const
{
  //## begin ParamData::min%373B0D30FFE2.get preserve=no
  return m_min;
  //## end ParamData::min%373B0D30FFE2.get
}

inline void ParamData::min (Real value)
{
  //## begin ParamData::min%373B0D30FFE2.set preserve=no
  m_min = value;
  //## end ParamData::min%373B0D30FFE2.set
}

inline const Real ParamData::top () const
{
  //## begin ParamData::top%373B0D30FFE5.get preserve=no
  return m_top;
  //## end ParamData::top%373B0D30FFE5.get
}

inline void ParamData::top (Real value)
{
  //## begin ParamData::top%373B0D30FFE5.set preserve=no
  m_top = value;
  //## end ParamData::top%373B0D30FFE5.set
}

inline const Real ParamData::bot () const
{
  //## begin ParamData::bot%373B0D30FFE6.get preserve=no
  return m_bot;
  //## end ParamData::bot%373B0D30FFE6.get
}

inline void ParamData::bot (Real value)
{
  //## begin ParamData::bot%373B0D30FFE6.set preserve=no
  m_bot = value;
  //## end ParamData::bot%373B0D30FFE6.set
}

//## begin module%382C7C8B7768.epilog preserve=yes
//## end module%382C7C8B7768.epilog


#endif
